void line (int xs,int ys,int xe,int ye);

status_t test_powerup()
{
	int i,j,k;
	vuint32 * framebuffer;
	vuint32 * temp;
	framebuffer = (vuint32 *) si->framebuffer;
	
	/*Nicole's mode switch code*/

	CFGW(DEVCTRL,(2|CFGR(DEVCTRL))); 
	/*enable device response (already enabled here!)*/

	VGAW_I(CRTC,0x11,0);
	/*allow me to change CRTC*/

	VGAW_I(SEQ,1,0x20);
	/*disable screen and various other bits*/

	VGAW_I(CRTCEXT,3,0x80);
	/*use powergraphix (+ trash other bits, they are set later)*/

	VGAW(MISCW,0x08);
	/*set only MGA pixel clock in MISC - I don't want to map VGA stuff under this OS*/

	DXIW(MULCTRL,0x4);
	/*RGBA direct mode*/

	/*CRTC setup, straight from your code*/
	VGAW_I(CRTC,0x0,0xa3);
	VGAW_I(CRTC,0x1,0x7f);
	VGAW_I(CRTC,0x2,0x7f);
	VGAW_I(CRTC,0x3,0x07);
	VGAW_I(CRTC,0x4,0x83);
	VGAW_I(CRTC,0x5,0x94);
	VGAW_I(CRTC,0x6,0x24);
	VGAW_I(CRTC,0x7,0xf5);
	VGAW_I(CRTC,0x8,0x00);
	VGAW_I(CRTC,0x9,0x60);
	VGAW_I(CRTC,0xa,0x0);
	VGAW_I(CRTC,0xb,0x0);
	VGAW_I(CRTC,0xc,0x0);
	VGAW_I(CRTC,0xd,0x0);
	VGAW_I(CRTC,0xe,0x0);
	VGAW_I(CRTC,0xf,0x0);
	VGAW_I(CRTC,0x10,0x3);
	VGAW_I(CRTC,0x11,0x9);
	VGAW_I(CRTC,0x12,0xff);
	VGAW_I(CRTC,0x13,0x00);
	VGAW_I(CRTC,0x14,0x00);
	VGAW_I(CRTC,0x15,0xff);
	VGAW_I(CRTC,0x16,0x25);
	VGAW_I(CRTC,0x17,0xc3);
	VGAW_I(CRTC,0x18,0x0);
	VGAW_I(CRTC,0x22,0x0);
	VGAW_I(CRTC,0x24,0x0);
	VGAW_I(CRTC,0x26,0x0);

	/*CRTCEXT setup - ditto*/
	VGAW_I(CRTCEXT,0,0x10);
	VGAW_I(CRTCEXT,1,0x00);
	VGAW_I(CRTCEXT,2,0x00);
	VGAW_I(CRTCEXT,3,0x83);
	VGAW_I(CRTCEXT,4,0x00);
	VGAW_I(CRTCEXT,5,0x00);
	VGAW_I(CRTCEXT,6,0x25);
	VGAW_I(CRTCEXT,7,0x00);

	/*set pixel clock*/
	DXIW(PIXCLKCTRL,DXIR(PIXCLKCTRL)|0x04);         /*disable the PIXPLL*/
	DXIW(PIXCLKCTRL,(DXIR(PIXCLKCTRL)&0x0C)|0x01);  /*select the PIXPLL*/
	VGAW(MISCW,((VGAR(MISCR)&0xF3)|0x8));           /*select PIXPLLC*/
	DXIW(PIXPLLCM,(2));				/*set m value*/
	DXIW(PIXPLLCN,(28));				/*set n value*/
	DXIW(PIXPLLCP,(2));                             /*set p value*/ //11= 0x1011
	while(!(DXIR(PIXPLLSTAT)&0x40));                /*wait for the PIXPLL frequency to lock*/
	DXIW(PIXCLKCTRL,DXIR(PIXCLKCTRL)&0x0B);         /*enable the PIXPLL*/

	LOG(100,"BLOOOOOOOOOOOOOOOOOOOOOOOOOOOOOP\n");

	/*skipped system clock, already set*/
		
	VGAW_I(SEQ,1,0x00);
	/*enable screen*/

	/*draw three coloured bars*/
	temp = framebuffer;
	for (i=0;i<768;i++)
	{
		for (j=0;j<1024;j++)
		{
			if (i>511)
			{
				k=i<<16;
			}
			else if (i>255)
			{
				k=i<<8;
			}
			else
			{
				k=i;
			}
			*temp++=k;
		}
	}

	/*draw a line or two!*/
	ACCW(PITCH,1024);        /*BUGFIX - width of 1024, not 32!*/
	ACCW(DSTORG,0x00);       /*start at beginning of framebuffer*/
	ACCW(MACCESS,0x2);       /*32bpp*/
	ACCW(PLNWT,0xFFFFFFFF);  /*all 32 bitplanes*/
	ACCW(FCOL,0xFFFFFFFF);   /*white*/

	line(10,10,10,700);
	line(500,10,500,700);
	line(10,350,500,350);
	line(600,10,1000,10);
	line(600,700,1000,700);
	line(800,10,800,700);

	/*do not run rest of driver*/
	for(;;); 

	return B_OK;

}

void line (int xs,int ys,int xe,int ye)
{
	ACCW(XYSTRT,((ys<<16)|xs)); /*start point*/
	ACCW(XYEND,((ye<<16)|(xe)));/*end point*/
	ACCGO(DWGCTL,0x840C4811);   /*draw it*/
}
